function [fval, time, methodparams]=optim_ga(fun,boundmin,boundmax,genrand,poprand)
% optimv2pso Function for automatizing pso run with options, timing and exporting
% 

if nargin==0
    fval = 'GA';
    return
end

% init
crossovers={@crossoverheuristic,@crossoverscattered,...
            @crossoverintermediate,@crossoversinglepoint,...
            @crossovertwopoint,@crossoverarithmetic};
c = randi([1 6]);
k = round(0.05*poprand*(1+rand));
options = gaoptimset...
    ('Generations',genrand,...
     'PopulationSize',poprand,...
     'CrossoverFcn',crossovers(c),...
     'EliteCount',k,...
     'Display','off');
% run
t=tic;
[~,fval] = ga(fun,length(boundmin),[],[],[],[],boundmin,boundmax,[],options);
time = toc(t);

% Creating data for exporting
if nargout>2
    methodparams={'Generations','Population','EliteCount',...
        'Crossover(1=heuristic,2=scattered,3=inter,4=single,5=two,6=arithmetic)';...
        genrand, poprand, k, c};
end