function [fval, time, methodparams]=optim_gaik(fun,boundmin,boundmax,genrand,poprand)
% optimv2pso Function for automatizing pso run with options, timing and exporting
% 

if nargin==0
    fval = 'GA-IK';
    return
end

% init
CR = 0.7+0.2*rand(1);
MS = 0.04+0.2*rand(1);
obj = ga_optim(@(x)(-fun(x)),1,genrand,poprand,0);
obj.SAFEMODE  = 0;
obj.PRINTMODE = 0;
obj.CR = CR;
obj.MS = MS;
for i = 1:length(boundmin)
    obj = obj.add_param([],[boundmin(i) boundmax(i)],0);
end
% run
t=tic;
obj = obj.run(boundmin);
fval = -obj.fitnessOpt;
time = toc(t);

% Creating data for exporting
if nargout>2
    methodparams={'Generations','Population','CrossoverRate','Mutation';...
                genrand, poprand, CR, MS};
end