function [fval, time, methodparams]=optim_gcluster(fun,dim,boundmin,boundmax,genrand,poprand)
% optimv_glcCluster Function for automatizing glcCluster run with options, timing and exporting
% 

if nargin==0
    fval = 'glcCluster';
    return
end
t=tic;

% optimisation with fine-tuned options
Prob = glcAssign(fun, boundmin, boundmax,[]);
Prob.PriLevOpt = 0;
Prob.optParam.IterPrint = 0;
Prob.optParam.MaxIter = 10*poprand;
Prob.optParam.MaxFunc = 10*genrand*dim;
solution = tomRun('glcCluster', Prob);
fval = solution.f_k;
time = toc(t);
% Creating data for exporting
 methodparams={'Max Iterations','Max Fun Evals'; 10*poprand, 10*genrand*dim};