function [fval, time, methodparams]=optim_glo(fun,boundmin,boundmax,genrand,poprand)
% optimv2pso Function for automatizing pso run with options, timing and exporting
% 

if nargin==0
    fval = 'GLuni';
    return
end

% init
OPT.N100    = poprand*50;
OPT.NG0     = length(boundmin)*2;
OPT.METHOD  = 'unirandi';
OPT.MAXFN   = genrand*25;
OPT.MAXNLM  = 60;

% run
t=tic;
[~,F0] = lGLOBAL(fun, boundmin', boundmax', OPT);
time = toc(t);
fval=F0(1);

% Creating data for exporting
if nargout>2
    methodparams={'Sample Points','Best Points','Max Evulation';...
        OPT.N100, OPT.NG0, OPT.MAXFN};
end