function [fval, time, methodparams]=optim_gsa(fun,boundmin,boundmax,genrand,poprand)
% optimv2gsa Function for automatizing gsa run with options, timing and exporting
% 
if nargin==0
    fval = 'GSA';
    return
end

% init
N=round(poprand/3); 
max_it=genrand*3; 
ElitistCheck=randi([1 2]); Rpower=randi([1 2]);
min_flag=1;        % 1=minimzation, 0=maximization, no need to change this

% run
t=tic;
fval=GSA(fun,N,max_it,ElitistCheck,min_flag,Rpower,boundmin,boundmax,length(boundmin));
time = toc(t);

if nargout>2
    methodparams={'Generations','Population','ElitistCheck','Rpower';...
        max_it, N, ElitistCheck, Rpower};
end