function [fval, time, methodparams]=optim_lgo(fun,dim,boundmin,boundmax,genrand,poprand)
% optimv_lgo Function for automatizing lgo run with options, timing and exporting
% 

if nargin==0
    fval = 'LGO';
    return
end
t=tic;
maxfct = 500*round(dim+poprand/100+genrand/100)*randi([1 3]);
nosuc = 100*round(dim+poprand/100+genrand/100)*randi([1 3]);
irngs = round(rand(1))*round(genrand/10);
% optimisation with fine-tuned options
Prob = glcAssign(fun, boundmin, boundmax,[]);
    Prob.Lgo.options.g_maxfct=maxfct;
    Prob.Lgo.options.max_nosuc=nosuc;
    Prob.Lgo.options.penmult=genrand;
    Prob.Lgo.options.irngs=irngs;
solution = tomRun('lgo', Prob);
fval = solution.f_k;
time = toc(t);
% Creating data for exporting
methodparams={'Max Fun Evals','Max Fun Evals w/o change','Constraint penalty multiplier',...
    'Random number seed'; maxfct, nosuc, genrand, irngs};