function [fval, time, methodparams]=optim_mm(fun,dim,boundmin,boundmax,genrand,poprand)
% optimv_mm Function for automatizing lgo run with options, timing and exporting
% 

if nargin==0
    fval = 'MultiMin';
    return
end
t=tic;
xinit = ((-1)^randi([1 2]))*min(poprand*dim,30*dim);
mx0 = round(genrand/2);
% optimisation with fine-tuned options
Prob = glcAssign(fun, boundmin, boundmax,[]);
Prob.xInit = xinit;
Prob.Mx0 = mx0;
solution = tomRun('multimin', Prob);
fval = solution.f_k;
time = toc(t);
% Creating data for exporting
methodparams={'Initial points(if <0 hypercube, else normal)','Number of best points';xinit,mx0};