function [fval time methodparams]=optim_ps(fun,boundmin,boundmax,genrand,poprand)
% optimv2ps Function for automatizing patternsearch run with options, timing and exporting
% 
if nargin==0
    fval = 'PS';
    return
end

% init
pollingorders={'Random', 'Success', 'Consecutive'};
c=randi([1 3]);
maxit=genrand*length(boundmin)/2;
maxevals=genrand*poprand*length(boundmin)*1.5;
me=1.5+poprand/100;
mc=me/4;
options = psoptimset...
     ('PollingOrder',char(pollingorders(c)),...
      'MaxIter',maxit,...
      'MaxFunEvals',maxevals,...
      'MeshContraction',mc,...
      'MeshExpansion',me,...
      'Display','off');
init = rand(1,length(boundmin)) .* (boundmax-boundmin) + boundmin;

% run
t=tic;
[~,fval] = patternsearch(fun,init,[],[],[],[],boundmin,boundmax,[],options);
time = toc(t);

% Creating data for exporting
if nargout>2
    methodparams={'Iterations','Evulations','MeshExpansion','MeshContraction',...
        'Polling Order(1=Random,2=Success,3=Consecutive)'; maxit, maxevals, me, mc, c};
end