function [fval, time, methodparams]=optim_pso(fun,boundmin,boundmax,genrand,poprand)
% optimv2pso Function for automatizing pso run with options, timing and exporting
% 

if nargin==0
    fval = 'PSO';
    return
end

% init
CArand=randi([5 7])/10;
SArand=CArand+1;
% optimisation with fine-tuned options
options = psooptimset...
    ('Generations',genrand,...
     'PopulationSize',poprand,...
     'CognitiveAttraction',CArand,...
     'SocialAttraction',SArand,...
     'Display','off');
% run
t=tic;
[~,fval] = pso(fun,length(boundmin),[],[],[],[],boundmin,boundmax,[],options);
time = toc(t);

% Creating data for exporting
if nargout>2
    methodparams={'Generations', 'Population','Cognitive Attraction','Social Attraction';...
        genrand, poprand, CArand, SArand};
end