function [fval, time, methodparams]=optim_sa(fun,boundmin,boundmax,genrand,poprand)
% optimv2sa Function for automatizing sa run with options, timing and exporting
% 
if nargin==0
    fval = 'SA';
    return
end

% init
anneals={@annealingboltz,@annealingfast};
c = randi([1 2]);
% optimisation with fine-tuned options
options = saoptimset...
    ('InitialTemperature',genrand,...
     'ReannealInterval',poprand,...
     'AnnealingFcn',anneals(c),...
     'Display','off');
init = rand(1,length(boundmin)) .* (boundmax-boundmin) + boundmin;

% run
t=tic;
[~,fval] = simulannealbnd(fun,init,boundmin,boundmax,options);
time = toc(t);

% Creating data for exporting
if nargout>2
    methodparams={'Generations','Population','Anneal Method(1=boltz,2=fast)';...
        genrand, poprand, c};
end