function [fval, time, methodparams]=optim_tlbo(fun,boundmin,boundmax,genrand,poprand)
% [fval, time, methodparams]=optim_tlbo(fun,boundmin,boundmax,genrand,poprand)
% Istvan Kecskes, 2013-08

if nargin==0
    fval = 'TLBO';
    return
end

genrand = round(genrand / 2);
poprand = round(poprand / 2);
elite = round(rand)*round(poprand/3*rand);
% run
t=tic;
[~, fval] = TLBO(fun,boundmin,boundmax,poprand,genrand,elite);
time = toc(t);

% Creating data for exporting
if nargout>2
    methodparams={'Generations', 'Population', 'Elites';...
                genrand,poprand,elite};
end