function [fitness, time, methodparams] = run_optim(methods,fcn,n )
% [fitness, time, methodparams] = run_optim(methods,fcn,n )
% Istvan Kecskes, 2013-08

    
    bound = fcn();
    fitness=zeros(length(methods), n);   %generating empty matrix for fitness
    time=zeros(length(methods), n);      %generating empty matrix for time
    if nargout>2
        methodparams=cell(length(methods),n);%generating empty cell for parameters    
    end
    for i=1:n
        genrand = randi([30 300]);        %random generations
        poprand = randi([15 100]);        %populations for each loop  
        disp([num2str(i) '/' num2str(n) ' Gen=' num2str(genrand) ', Pop=' num2str(poprand)]);
        progressbar([],(i-1)/n);
        for m=1:length(methods)
            if nargout>2
                [fitness(m,i), time(m,i), methodparams{m,i}]=methods{m}...
                              (fcn,bound(1,:),bound(2,:),genrand,poprand);
            else
                [fitness(m,i), time(m,i)]=methods{m}...
                        (fcn,bound(1,:),bound(2,:),genrand,poprand);
            end
        end
    end
end
